#include	<types.h>
#include	<quickdraw.h>
#include	<toolutils.h>
#include	<events.h>
#include	<windows.h>
#include	<dialogs.h>
#include	<menus.h>
#include	<desk.h>
#include	<textedit.h>
#include	<scrap.h>
#include	<segload.h>
#include 	<memory.h>
#include 	<strings.h>
#include 	<resources.h>
#include 	<files.h>
#include 	<fonts.h>
#include 	<StandardFile.h>
#include	<OSUtils.h>
#include	<Files.h>
#include	<OSEvents.h>
#include	<Errors.h>
#include 	<palettes.h>
#include	<appleevents.h>
#include	<SysEqu.h>
#include 	<GestaltEqu.h>
#include	<FixMath.h>
#include	<Packages.h>

#include	<Movies.h>
#include 	<ImageCompression.h>

#include <Printing.h>
#include <QDOffscreen.h>

#define nil 0L
#define VIDEO_TYPE		'vide'

/* Printing stuff */
/* 	This error should be defined in Printing.h, but isn't (apparently
	because all of Apple's drivers support PrGeneral, so this error will
	never occur). */
	
#define OpNotImpl	2	/*
 * Resource ID constants.
 */
#define	appleID			128 			/* This is a resource ID */
#define	fileID 			129 			/* ditto */
#define	editID 			130 			/* ditto */
#define moovieID		131				/* same */
#define pictsID			132

#define	appleMenu		0				/* MyMenus[] array indexes */
#define	aboutMeCommand	1

#define	fileMenu		1
#define newMovie		1
#define loadMovie		2
#define closeMovie		3
#define saveMovie		5
#define saveMovieAs		6
#define printCommand	8
#define pageCommand		9
#define	quitCommand 	11

#define	editMenu		2
#define	undoCommand 	1
#define	cutCommand		3
#define	copyCommand 	4
#define	pasteCommand	5
#define	clearCommand	6
#define selectAllCommand 7

#define moovieMenu		3
#define stplayMovie		1
#define soundMovie		2
#define advFrMovie		3
#define revFrMovie		4
#define loopMovie		5
#define weirdLoopMovie	6
#define editMovie		7

#define pictsMenu		4
#define getTrackPicts	1
#define get1MoviePict	2

#define menuCount		 5
/*
 * For the one and only text window
 */
#define windowID		128
/*
 * For DLOG's
 */
#define	aboutMeDLOG		128
#define	okButton		1
#define cancelButton	2

#define	authorItem		2			/* For SetIText */
#define	languageItem	3			/* For SetIText */
#define rBadMooviesALRT	429
#define rNotSeven		430

#define rYesNoCancel	250
#define rCustomPut		300
#define rProgress		450

#define	rUserAlert			129		/* error user alert */
#define	rLandscapeAlert		130		/* landscape orientation set user alert */
#define	r32BitQDAlert   	131     /* 32-bit QD required alert */
#define	rNOPrGeneralAlert   132     /* the NOPrGeneral alert */

#define MacScreenRes		72		/* The resolution of the Mac screen */			
#define	FontSize			12
#define	VertMargin			40

/* miscellaneous string list ID */
#define rMiscStrings 366
#define sSFprompt 1
#define sOrigName 2
#define sClosing  3
#define sQuitting 4

#define kSaveYes		1
#define kProgressCanceled 3
#define kSaveCanceled	4
#define kFlattenMovie	13
#define kInvalVRefNum	0
#define kButtonFrameInset		(-4)		/* inset rectangle adjustment around button */
#define kCntlActivate			0
#define kButtonFrameSize		3			/* button frames pen size */

#define kNoFileOpen				-1
#define kNoResourceYet			128		/* -1 has some mistical meaning in this context */

#define kTimeScale 10			/*  10 frames per second */

#define GetMBarHeight() (* (short*) 0x0BAA)
#define TopLeft(r)		(* (Point *) &(r).top)
#define BotRight(r)		(* (Point *) &(r).bottom)

/* the following struct contains the info on the movie file */
typedef struct {
	StandardFileReply sfr;		/* original file			*/
	short	resFile;			/* file id					*/
	short	moovID;				/* resource id				*/
}	MovieFileRec, *MovieFileRecPtr, **MovieFileRecHandle;


/* for each window this record holds the info regarding the moovie */
typedef struct {
	Movie		wMovie;					/* the movie  				*/
	MovieController	wPlayer;			/* the player instance		*/
	MovieFileRec wFileInfo;				/* original file			*/
	short		soundVolume;
}	DocRec, *DocRecPtr, **DocRecHandle;


#define SETRECT(rectp, _left, _top, _right, _bottom)	\
	(rectp)->left = (_left), (rectp)->top = (_top), 	\
	(rectp)->right = (_right), (rectp)->bottom = (_bottom)

/*
 * HIWORD and LOWORD macros, for readability.
 */
#define HIWORD(aLong)		(((aLong) >> 16) & 0xFFFF)
#define LOWORD(aLong)		((aLong) & 0xFFFF)
